﻿#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using HeuristicLab.Problems.Scheduling.Interfaces;
using HeuristicLab.Core;
using HeuristicLab.Parameters;
using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
using HeuristicLab.Common;

//ATTENTION: This class is never used because most manipulation operators dont require specific information about the problem..
namespace HeuristicLab.Problems.Scheduling.Encodings.JobShopScheduling {
  [Item("JobShopScheduling Problem Manipulator", "Represents the generalized form of decoder for JobShop Scheduling Problems.")]
  [StorableClass]
  public abstract class JSSPManipulator<T> : SchedulingManipulator<T>, IJSSPOperator where T : Item, IJSSPEncoding {
    [StorableConstructor]
    protected JSSPManipulator(bool deserializing) : base(deserializing) { }
    protected JSSPManipulator(JSSPManipulator<T> original, Cloner cloner)
      : base(original, cloner) {
    }

    #region Parameter Properties
    public ILookupParameter<ItemList<JSSPJob>> JobsParameter {
      get { return (ILookupParameter<ItemList<JSSPJob>>)Parameters["Jobs"]; }
    }
    #endregion
    #region Properties
    public ItemList<JSSPJob> Jobs {
      get { return JobsParameter.ActualValue; }
    }
    #endregion

    public JSSPManipulator()
      : base() {
      Parameters.Add(new LookupParameter<ItemList<JSSPJob>>("Jobs", "Jobdata defining the precedence relationships and the duration of the tasks in this JSSP-Instance."));
    }
  }
}
